## org.hibernate.bytecode
Interface ProxyFactoryFactory

All Known Implementing Classes:
  ProxyFactoryFactoryImpl, ProxyFactoryFactoryImpl

    public interface ProxyFactoryFactory

An interface for factories of `proxy factory` instances.

Currently used to abstract from the tupizer whether we are using CGLIB or Javassist for lazy proxy generation.

Author:
  Steve Ebersole

Method Summary
`BasicProxyFactory` `buildBasicProxyFactory(Class superClass, Class[] interfaces)` Build a proxy factory for basic proxy concerns.
`ProxyFactory` `buildProxyFactory()` Build a proxy factory specifically for handling runtime lazy loading.

Method Detail

### buildProxyFactory

    ProxyFactory buildProxyFactory()

  Build a proxy factory specifically for handling runtime lazy loading.

  Returns:
    The lazy-load proxy factory.

### buildBasicProxyFactory

    BasicProxyFactory buildBasicProxyFactory(Class superClass,
                                             Class[] interfaces)

  Build a proxy factory for basic proxy concerns. The return should be capable of properly handling newInstance() calls.

  Should build basic proxies essentially equivalent to JDK proxies in terms of capabilities, but should be able to deal with abstract super classes in addition to proxy interfaces.

  Must pass in either superClass or interfaces (or both).

  Parameters:
    `superClass` - The abstract super class (or null if none).
    `interfaces` - Interfaces to be proxied (or null if none).
  Returns:
    The proxy class

Copyright © 2001-2010 Red Hat, Inc. All Rights Reserved.